# IBM_PROLOG_BEGIN_TAG
# This is an automatically generated prolog.
#
# esa61L src/bos/usr/sbin/install/esa/lib/ESA/Constants.pm 1.7.1.1
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2007,2010
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
package Constants;

# Agent installation directory
use constant AGENT_INSTALL_DIR => "/opt/ibm/esa/eclipse";

# Activation log
use constant ACTIVATION_LOG => "/opt/ibm/esa/log/activation.log";

# License agreement
use constant LICENSE_LOG => "/opt/ibm/esa/log/la.log";
use constant LICENSE_DIR => "/opt/ibm/esa/data/license";
use constant LICENSE_PROG => "/opt/ibm/esa/bin/reviewLA";

# Workspace
use constant WORKSPACE => "/opt/ibm/esa/workspace";

# Location of the ESA LWI Instance
use constant EQUINOXROOT => "/opt/ibm/esa/runtime";

# Bos vendor file
use constant BOSVENDORFILE => "/usr/lpp/bosinst/bos.vendor.profile";

# ISO Country List
use constant ISO_FILE => "/opt/ibm/esa/lib/iso-country-list";

# File to determine if we have been previously activated.
use constant ESAACTIVATED => "/opt/ibm/esa/locks/activated.lck";

# File to mark if legacy pSA was found on this system
use constant LEGACY_PSA_FOUND => "/opt/ibm/esa/locks/legacy_psa.lck";

# Debugging flags used for API debugging
# use constant DEBUG_ESAAPI_BASIC => " -Dorg.apache.commons.logging.Log=org.apache.commons.logging.impl.SimpleLog -Dorg.apache.commons.logging.simplelog.showdatetime=true -Dorg.apache.commons.logging.simplelog.log.com.ibm.esa=debug";
# use constant DEBUG_ESAAPI_FULL => " -Dorg.apache.commons.logging.simplelog.log.httpclient.wire=debug -Dorg.apache.commons.logging.simplelog.log.org.apache.commons.httpclient=debug -Dorg.apache.commons.logging.simplelog.showdatetime=true -Dorg.apache.commons.logging.simplelog.log.com.ibm.esa.api=debug ";
use constant DEBUG_ESAAPI_FULL => "";
use constant DEBUG_ESAAPI_BASIC => "";

# SRC - System Resource Controller
use constant START_CMD => '/opt/ibm/esa/bin/start_esa';
use constant SRC_NAME => 'IBM.ESAGENT';
use constant SRC_USER => 'esaadmin';
use constant SRC_GROUP => 'ibmsrv';
use constant ESA_STDIN => '/dev/null';
use constant ESA_STDOUT => '/opt/ibm/esa/log/STDOUT';
use constant ESA_STDERR => '/opt/ibm/esa/log/STDERR';

# Java 1.5 install directory
# This constant is unused. Commented out to ENSURE it's unused.
# Java runtimes are selected in Activation.pm and in esa_install_post.
###### use constant JAVA => '/XXXXopt/ibm/java-ppc64-60/jre/bin/java ';

# NLS Catalog
use constant NLS_CATALOG => 'esa.cat';

# Default IMPORT File for Activation
use constant ESA_IMPORT_FILE => "/opt/ibm/esa/data/IBM_ESAconfig.properties";
use constant ESA_RESULT_FILE => "/opt/ibm/esa/data/API_result_file";

# Default Legacy Dump
use constant LEGACY_DUMP_FILE => "/tmp/sagent_upgrade.xml";

# Contact Information & other basic data
use constant CONFIG_FILE_VERSION => "CONFIG_FILE_VERSION";
use constant R_COMPANY_NAME  => "R_COMPANY_NAME";
use constant R_CONTACT_NAME => "R_CONTACT_NAME";
use constant R_COUNTRY_OR_REGION => "R_COUNTRY_OR_REGION";
use constant R_PHONE_NUMBER => "R_PHONE_NUMBER";
use constant R_EMAIL_ADDRESS => "R_EMAIL_ADDRESS";
use constant R_LOCATION_COUNTRY => "R_LOCATION_COUNTRY";
use constant R_LOCATION_PHONE => "R_LOCATION_PHONE";
use constant LOCATION_ADDRESS1 => "LOCATION_ADDRESS1";
use constant LOCATION_CITY_OR_LOCALITY => "LOCATION_CITY_OR_LOCALITY";
use constant LOCATION_STATE_OR_PROVINCE => "LOCATION_STATE_OR_PROVINCE";
use constant LOCATION_ZIP_OR_POSTAL_CODE => "LOCATION_ZIP_OR_POSTAL_CODE";
use constant LOCATION_BUILDING => "LOCATION_BUILDING";

use constant R_SEC_CONTACT_NAME => "R_SEC_CONTACT_NAME";
use constant R_SEC_CONTACT_PHONE_NUMBER => "R_SEC_CONTACT_PHONE_NUMBER";
use constant R_SEC_CONTACT_EMAIL_ADDRESS => "R_SEC_CONTACT_EMAIL_ADDRESS";

use constant IBMID_1 => "IBMID_1";
use constant SERVICE_AGENT_PORT => "SERVICE_AGENT_PORT";
use constant VAL_CONFIG_FILE_VERSION_DEF => "1.1";
use constant VAL_SERVICE_AGENT_PORT_DEF => "5024";

use constant RC_ESA_D => "/opt/ibm/esa/bin/esactl";
use constant ESACTL => "esactl";
use constant RC_ESA_D_LINK => "/etc/init.d/esactl";
use constant CHKCONFIG => "/sbin/chkconfig";
use constant RUNLEVELS => " 2345";

use constant SYSTEMCTL => "/usr/bin/systemctl";
use constant CHMOD_ESACTL_UNILT_FILE => "chmod 0777 /usr/lib/systemd/system/esactl.service >/dev/null 2>&1";
use constant ADD_UNIT_FILE => "mv -f /opt/ibm/esa/lib/ESA/esactl.service /usr/lib/systemd/system/ >/dev/null 2>&1";
use constant RM_UNIT_FILE => "mv -f /usr/lib/systemd/system/esactl.service /opt/ibm/esa/lib/ESA/ >/dev/null 2>&1";
use constant ENABLE_SYSTEMD_ESACTL => "systemctl enable esactl >/dev/null 2>&1";
use constant DISENABLE_SYSTEMD_ESACTL => "systemctl disable esactl >/dev/null 2>&1";
use constant SYSTEMCTL_START_ESACTL => "systemctl start esactl >/dev/null 2>&1";
use constant SYSTEMCTL_STOP_ESACTL => "systemctl stop esactl >/dev/null 2>&1";

use constant AU_STATES => "/opt/ibm/esa/lib/ESA/au_states";
use constant US_STATES => "/opt/ibm/esa/lib/ESA/us_states";
use constant ESA_INSTALL_DIR => "/opt/ibm/esa";
use constant ESA_DIAG_CMD => "/opt/ibm/esa/bin/esagent.diag";
use constant YES =>"yes";
use constant PAIRS_STDIN => "pairs_stdin";
use constant SERVICELOG_NOTIFY =>"servicelog_notify ";
use constant STATUS => "status";
use constant SAVE => "save";
use constant CLEAR => "clear";
use constant ENABLE => "enable";
use constant IPTABLES =>"iptables";
use constant FIREWALLD =>"firewalld";
 use constant FIREWALL_CMD =>"firewall-cmd";
use constant IPTABLES_SAVE =>"iptables-save";
use constant IPTABLES_RESTORE =>"iptables-restore";
use constant SWITCH => "switch";
use constant SUSE_FW_CFG => "/etc/sysconfig/SuSEfirewall2";
use constant FW_NOT_ACTIVE =>0;
use constant FW_SUSE2_ACTIVE =>1;
use constant FW_RHEL1_ACTIVE =>2;
use constant FW_RHEL7_ACTIVE =>3;
use constant FW_HMC_ACTIVE =>4;
use constant SUSE_FIREWALL_2 =>"/sbin/SuSEfirewall2";
use constant SERVICE_BIN => "/sbin/service";
use constant MSG_FIREWALL_NOT_ACTIVE =>"No supported firewalls are active on the system. Start firewall and run the command again.";
use constant MSG_FIREWALL_NOT_ACTIVE_STATUS =>"No supported firewalls are active on the system.";
use constant MSG_FIREWALL_NOT_ACTIVE_4_ACTIVATOR =>"Ignoring -w option since no supported firewalls are active on this system.";
use constant MSG_FIREWALL_ACTIVE_WARNING =>"Use /opt/ibm/esa/bin/esafirewall command to expose ESA webui to remote browsers.";
use constant CMD_FAILED =>-1;
use constant CONNECTION_TYPE_1 =>"CONNECTION_TYPE_1";

1;
