# IBM_PROLOG_BEGIN_TAG
#
#Esaclient 1.0.0
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2014,2017
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Apr 17, 2014
@author: Chen Shao Jie
'''

import os
import configparser
from queue import Queue

pendingList = []
q = Queue()
#alertQueue = q.get_nowait()
MAX_THREAD = 3
threadsNumber = []
stopSendTrap = False
IBM_ENTSPECIFIC_TRAP = str(".1.3.6.1.4.1.2.6.251")
SE_TRAP_EVENT = IBM_ENTSPECIFIC_TRAP + str(".1")
SE_TRAP_EVENT_OBJECTS = IBM_ENTSPECIFIC_TRAP + str(".2")


SE_TRAP_DATETIME = SE_TRAP_EVENT_OBJECTS + str(".1")
SE_ERROR_OCCURTIME = SE_TRAP_EVENT_OBJECTS + str(".2")
SE_LOGID = SE_TRAP_EVENT_OBJECTS + str(".3")
SE_SRC = SE_TRAP_EVENT_OBJECTS + str(".4")
SE_FAILIING_SUB_SYS = SE_TRAP_EVENT_OBJECTS + str(".5")
SE_ACTION_FLG = SE_TRAP_EVENT_OBJECTS + str(".6")
SE_TRAP_APP_ID = SE_TRAP_EVENT_OBJECTS + str(".7")
SE_AGENT_NAME = SE_TRAP_EVENT_OBJECTS + str(".8")
SE_AGENT_TYPE = SE_TRAP_EVENT_OBJECTS + str(".9")
SE_AGENT_HOSTIP = SE_TRAP_EVENT_OBJECTS + str(".10")
SE_AGENT_HOSTNAME = SE_TRAP_EVENT_OBJECTS + str(".11")
SE_SYS_OS_NAME = SE_TRAP_EVENT_OBJECTS + str(".12")
SE_SYS_OS_TYPE = SE_TRAP_EVENT_OBJECTS + str(".13")
SE_SYS_OS_VERSION = SE_TRAP_EVENT_OBJECTS + str(".14")
SE_SYS_TYPE = SE_TRAP_EVENT_OBJECTS + str(".15")
SE_SYS_MODEL = SE_TRAP_EVENT_OBJECTS + str(".16")
SE_SYS_SERIAL_NUMBER = SE_TRAP_EVENT_OBJECTS + str(".17")
SE_SYS_FIRMWARE = SE_TRAP_EVENT_OBJECTS + str(".18")
SE_VMID = SE_TRAP_EVENT_OBJECTS + str(".19")
SE_EXTENDED_ERRORDATA = SE_TRAP_EVENT_OBJECTS + str(".20")
SE_ADDITIONAL_DETAILS = SE_TRAP_EVENT_OBJECTS + str(".21")
SE_TEST_FLG = SE_TRAP_EVENT_OBJECTS + str(".22")


# Traps
IBM_TRAP_SERVICE_AND_CALLHOME = SE_TRAP_EVENT + str(".1")
IBM_TEST_TRAP_SERVICE = SE_TRAP_EVENT + str(".2")




APPLICATION_ROOT = os.path.abspath('.').replace("bin", "")
APP_INSTALL_DIR = "/opt/ibm"
APP_FILES_DIR = "/var"
APPLICATION_NAME = "esaclient"
APPLICATION_ROOT = os.path.join(APP_INSTALL_DIR, APPLICATION_NAME)
APP_FILES_PATH = os.path.join(APP_FILES_DIR, APPLICATION_NAME)
APP_DATA_PATH = os.path.join(APPLICATION_ROOT, "data")
APPLICATION_ID = "esaclient_runtime"

#APP_INSTALL_DIR = "c:\vindata"
#APP_FILES_DIR = "c:\vindata"
#APPLICATION_NAME = "esaclient"
#APPLICATION_ROOT = os.path.join(APP_INSTALL_DIR, APPLICATION_NAME)
#APP_FILES_PATH = os.path.join(APP_FILES_DIR, APPLICATION_NAME)
#APP_DATA_PATH = os.path.join(APP_FILES_PATH, "data")
#APPLICATION_ID = "esaclient_runtime"


CONFIGFILE = os.path.join(APPLICATION_ROOT, "conf", "conf.properties")
#CONFIGFILE = os.path.join("../", "conf", "conf.properties")
config = configparser.ConfigParser()
config.read(CONFIGFILE)

# snmptrap path
CMD_GERNERATE_SYS_INFO = os.path.join(APPLICATION_ROOT, "bin", "sys.discover")
SYS_INFO = os.path.join(APP_DATA_PATH, "sysinfo.cached")
INTERVAL = 3600 * 8

# test alert
ALERT_FLG = 0
TEST_CONTENT = "testAlert"
HOST_NAME = ""
HOST_IP_PORT = ""
HOST_COMMUNITY = ""
VERSION = ""
AGENT_LOCKS=os.path.join(APP_FILES_PATH, "locks")
# agent process id file
AGENT_PID_FILE = os.path.join(AGENT_LOCKS, "agent.pid")
LOG4P_PATH = os.path.join(APPLICATION_ROOT, "lib", "log4p.conf")
#LOG4P_PATH = os.path.join("../", "lib", "log4p.conf")
TEMP_FILE = os.path.join(APPLICATION_ROOT, "bin", "tmpfile")
SYS_LOG = "/var/log/messages"
REQ_SERVICE_ACTION_AND_CALL_HOME = ":Service action and call home required"
REQ_SERVICE_ACTION_AND_NO_CALL_HOME = ":Service action required"
DIAG_ENCL = "DIAG_ENCL"
MAX_QUEUE_SIZE = 50000
ENABLE_SERVICE="systemctl enable esaclientctl >/dev/null 2>&1"
DISABLE_SERVICE="systemctl disable esaclientctl >/dev/null 2>&1"
START_SERVICE="systemctl start esaclientctl  >/dev/null 2>&1"
STOP_SERVICE="systemctl stop esaclientctl  >/dev/null 2>&1"
STOPPED="ESAClient stopped successfully\n"
SEP_NOT_RUNNING="ESAClient is not running\n"
SEP_RUNNING="ESAClient is running\n"
SEP_STARTED="ESAClient started successfully\n"
SEP_RESTARTED="ESAClient restarted successfully\n"
SEP_UNINSTALLED="ESAClient is un installed.\n"
APPLICATION_LOGS=os.path.join(APP_FILES_PATH, "logs")
LAST_ERROR_FILE=os.path.join(APPLICATION_LOGS, "lasterror")

#schedular constants
SCHEDULE_JOB_TYPE="jobType"
SCHEDULE_INTERVAL_STRING="intervalString"
SCHEDULE_TIME_STRING="timeString"
DAEMON_SCHEDULE ="Daemon_Schedule"
PROVIDER_KEY="provider_key"
PROVIDER_HEARTBEAT="heartbeat"
PROBLEM_PROVIDER="problemprovider"
SCHEDULE_PATTERN_DELIMITER=","
SCHEDULE_PATTERN_REGEX="^[cC]$|^([sS]{1})(\s*,\s*)?([0-9]+[sShHmMdDwW]{1}\s*?,*s?([0-2]{0,1}[0-9]{1}:[0-6]{0,1}[0-9]{1})?){1}$"

CONTINUOUS_JOB_TYPE_ONE_TIME="onetime"
CONTINUOUS_JOB_TYPE_RECURRING="recurring"




#CSEA discover by runtime
SERVER_MULTICAST_ADDRESS = str(config.get("LOCATE_CSESA", "SERVER_MULTICAST_ADDRESS"))
SERVER_MULTICAST_PORT = config.get("LOCATE_CSESA", "SERVER_MULTICAST_PORT")
RECEIVER_PORT = config.get("LOCATE_CSESA", "RECEIVER_PORT")
RECEIVER_TIMEOUT = config.get("LOCATE_CSESA", "RECEIVER_TIMEOUT")
CSESA_VERSION = config.get("LOCATE_CSESA", "CSESA_VERSION")


#System information
END_NAME = "name"
END_APP_OWNER = "app.owner";
END_IP_ADDR = "ip.address";
END_PROD_HARD = "product.hardware";
END_PROD_HARD_INFO = "info.about";
END_PROD_HARD_MODEL = "Model";
END_PROD_HARD_MT = "MachineType";
END_PROD_HARD_SN = "SerialNumber";
END_PROD_HARD_DESP = "description";
END_PROD_HARD_VENDOR = "vendor";
END_PROD_SOFT = "product.software";
END_PROD_SOFT_INFO = "info.about";
END_PROD_SOFT_COMP = "CompID";
END_PROD_SOFT_PRODID = "ProductID";
END_PROD_SOFT_DIV = "Division";
END_PROD_SOFT_DESP = "description";
END_PROD_SOFT_VENDOR = "vendor";
END_VIRTUALID = "Virtual-ID";
END_PARTNUM = "PartNumber";
END_OS_TYPE = "os.type";
END_OS_NAME = "os.name";
END_OS_VERSION = "os.version";
END_HOSTNAME = "hostname";
END_OS_ARCH = "os.arch";
END_TYPE = "EndpointType";
END_FIRMWARE_INFO = "firmware.info";
END_END_ARCH = "endpoint.architecture";
END_RELATED_END = "related-endpoints";
END_ENDPOINT_TYPE = "EndpointType";
END_ENDPOINT_ARCH = "endpoint.architecture";

#Problem information
EVENT_SYSTEMID = "system.id"
EVENT_ID = "event.id"
EVENT_CLIENT_ID = "event.client.id"
EVENT_TS = "event.original.timestamp"
EVENT_ERROR_CODE = "error.code"
EVENT_RESOURCE_NAME = "resource.name"
EVENT_SERVICEABILITY = "event.serviceability"
EVENT_SEVERITY = "severity"
EVENT_DESCRIPTION = "event-description"
EVENT_DETAILS = "event-details"
EVENT_STATUS = "status"
EVENT_TICKET_NO = "ticket.no"

PROBLEM_EVENT_FILE = "ProblemEvent"
