# IBM_PROLOG_BEGIN_TAG
#
# serviceable.event.provider 1.0.0
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2014,2014
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Sep 13, 2017
@author: Miguel Angel Guzman Pantoja
'''

import subprocess
import ApplicationConstants
import json
import urllib2

class RegistrySystem:

    #Fields for registry system
    NAME = "name"
    HOSTNAME = "hostname"
    APP_OWNER = "app.owner"
    INFO_ABOUT_SOLUTION = "solution"
    INFO_ABOUT_BASIC = "basic"
    PRODUCT_HARD = "product.hardware"
    INFO_ABOUT = "info.about"
    MODEL = "Model"
    MACHINE_TYPE = "MachineType"
    SN = "SerialNumber"
    DESC = "description"
    VENDOR = "vendor"
    VIRTUAL_ID = "Virtual-ID"
    PART_NUMBER = "PartNumber"
    OS_TYPE ="os.type"
    OS_VERSION = "os.version"
    OS_ARCH = "os.arch"
    ENDPOINT_TYPE = "EndpointType"
    FIRMWARE_INFO = "firmware.info"
    ENDPOINT_ARCH = "endpoint.architecture"

    def registrysys(self):
        sysdiscover = subprocess.Popen(ApplicationConstants.SYS_DISCOVER, shell=True, stdout=subprocess.PIPE,
                             stderr=subprocess.STDOUT)
        sysinfo = []
        for line in sysdiscover.stdout.readlines():
            if len(line.split("=")) > 1:
                sysinfo.append(line.split("=")[1][1:-1])

        sysparam = {RegistrySystem.NAME: sysinfo[0],
                    RegistrySystem.HOSTNAME: sysinfo[0],
                    RegistrySystem.APP_OWNER: ApplicationConstants.APPLICATION_NAME,
                    RegistrySystem.PRODUCT_HARD: [{RegistrySystem.INFO_ABOUT: RegistrySystem.INFO_ABOUT_BASIC,
                        RegistrySystem.MODEL: sysinfo[2],
                        RegistrySystem.MACHINE_TYPE: sysinfo[1],
                        RegistrySystem.SN: sysinfo[3],
                        RegistrySystem.DESC: "Description",
                        RegistrySystem.VENDOR: sysinfo[4]}],
                    RegistrySystem.VIRTUAL_ID: sysinfo[10],
                    RegistrySystem.PART_NUMBER: "PartNumber",
                    RegistrySystem.OS_TYPE: sysinfo[6],
                    RegistrySystem.OS_VERSION: sysinfo[7],
                    RegistrySystem.OS_ARCH: "Arch",
                    RegistrySystem.ENDPOINT_TYPE: sysinfo[5],
                    RegistrySystem.FIRMWARE_INFO: sysinfo[19],
                    RegistrySystem.ENDPOINT_ARCH: "Arch"}

        restURL = "http://" + sysinfo[0] + ":5023/rest/v1/endpoint"

        data = json.dumps(sysparam)
        httpRequest = urllib2.Request(restURL, data=data)
        httpRequest.add_header("Content-Type", 'application/json')
        httpRequest.get_method = lambda: 'POST'
        dataJson = ""

        try:
            httpResponse = urllib2.urlopen(httpRequest)

            print "httpResponseCode is {0}".format(httpResponse.getcode())
            if httpResponse.getcode() == 200:
                # success
                if httpResponse.info().gettype() == 'application/json':
                    dataJson = json.loads(httpResponse.read())

        except urllib2.HTTPError as he:
            print "urllib2.HTTPError ({0}): {1}".format(he.code, he.msg)
        except urllib2.URLError as ue:
            print "urllib2.URLError ({0}): {1}".format(ue.code, ue.message)
        except BaseException as be:
            print "BaseException {0}".format(be)

        return dataJson

if __name__ == "__main__":
    print RegistrySystem().registrysys()
