# IBM_PROLOG_BEGIN_TAG
#
# serviceable.event.provider 1.0.0
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2018,2018
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Oct 19, 2018

@author: Jing Cao
'''

import sys
import os

def readConf(path):
    myDict = {}
    if not os.path.isfile(path):
        print("propertity file not exist!")
        return False
    fp = open(path , "r")
    try:
        line = fp.readline()
        while line:
            line = line.strip(' \t\n')
            if line and not line.startswith("#"):
                list = line.split("=")
                list[0] = list[0].strip(' \t\n')
                list[1] = list[1].strip(' \t\n')
                myDict[ list[0] ] = list[1]
            line = fp.readline()
    finally:
        fp.close()
    return myDict

def getEsaUrl():
    confFile = readConf("/opt/ibm/esaclient/conf/ESA-URLS-USER.conf")
    if(confFile.get("primary")):
        return confFile.get("primary")
    if(confFile.get("secondary")):
        return confFile.get("secondary")
    if(confFile.get("ternary")):
        return confFile.get("ternary")

if __name__ == "__main__":

#   it ensures that the log config file is changed so that the log file is created at the appropriate place

    confFile = readConf("/opt/ibm/esaclient/conf/ESA-URLS-USER.conf")
    if(confFile.get("primary")):
        print(confFile.get("primary"))
    if(confFile.get("secondary")):
        print(confFile.get("secondary"))
    if(confFile.get("ternary")):
        print(confFile.get("ternary"))

    sys.exit(0)


