# IBM_PROLOG_BEGIN_TAG
#
# serviceable.event.provider 1.0.0 
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2014,2014
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Apr 16, 2014

@author: Chen Shao Jie
'''

import sys
import os
import ApplicationConstants
import ApplicationNotify
import ApplicationUtils
import ParseErrorLog
import SynchronizConf

def usage():
    print ("")
    print ("USAGE: sendTestEvent [hostip|hostname] [s|c]")
    print ("")
    print ("OPTIONS:")
    print ("[hostip|hostname]           destination host ip or host name")
    print ("[s]                         service action required alert")
    print ("[c]                         service action and call home required alert")
    print ("")
    print (" e.g: sendTestEvent 9.5.103.115 s")
    print ("")
    sys.exit(1)
    
if __name__ == "__main__": 
    if len(sys.argv) == 2:
        if '-k'==sys.argv[1] or '-h'==sys.argv[1] or '--help'==sys.argv[1]:
            usage()
            
        
    if len(sys.argv) == 3:
        if 's'==sys.argv[2] or 'c' ==sys.argv[2]:
            ApplicationConstants.ALERT_FLG = 1
            ApplicationConstants.HOST_IP_PORT = sys.argv[1]
        else:
            usage()
    else:
        usage()
        
    # test log
    if 's'==sys.argv[2]:
        log = "Jan 13 00:42:30 localhost ELOG[24831]: LID[502cdb2e]::SRC[SEP-TEST]::Test Problem from SEP::Informational Error::service action required"
    else:
        log = "Jan 13 00:42:30 localhost ELOG[24831]: LID[502cdb2e]::SRC[SEP-TEST]::Test Problem from SEP::Informational Error::Service action and call home required"
    
#   it ensures that the log config file is changed so that the log file is created at the appropriate place    
    SynchronizConf.synchronizConf()
        
    parseErrorLog = ParseErrorLog.ParseErrorLog()
    logentry = parseErrorLog.parseLogEntry(log)
    
    ApplicationUtils.ApplicationUtils().doSysDiscover()
    appNotify = ApplicationNotify.ApplicationNotify(logentry)
    appNotify.invokeRest()
# use the log entry and make a rest call    
    
    print ("")
    print ("Test event alert was sent out " + "[" + " " + sys.argv[1] + "]")
    
    ApplicationConstants.ALERT_FLG = 0
    
    sys.exit(0)
