# IBM_PROLOG_BEGIN_TAG
#
# serviceable.event.provider 1.0.0 
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2014,2014
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Apr 17, 2014
@author: Chen Shao Jie
'''
import threading, ApplicationNotify
import ApplicationUtils
import MonitorErrorLog
import SynchronizConf


class _stratMonitorErrorLog(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
    
    def run(self):
        # start monitor error log module
        MonitorErrorLog.MonitorErrorLog().monitor()
    
class _startSysDiscover(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
    
    def run(self):
        ApplicationUtils.ApplicationUtils().startSysDiscover()
        
class _startSendTrap(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
    
    def run(self):
        ApplicationUtils.ApplicationUtils().startSendTrap()

def start():
    SynchronizConf.synchronizConf()
    ApplicationUtils.ApplicationUtils().tracelogger().info("configure file was started!")
    
    thread1 = _stratMonitorErrorLog()
    thread1.start()
    ApplicationUtils.ApplicationUtils().tracelogger().info("monitor error log started!")
    
    thread2 = _startSysDiscover()
    thread2.start()
    ApplicationUtils.ApplicationUtils().tracelogger().info("system discovery started!")
    
    thread3 = _startSendTrap()
    thread3.start()
    ApplicationUtils.ApplicationUtils().tracelogger().info("sending traps started!")
    ApplicationUtils.ApplicationUtils().tracelogger().info("serviceable event provider started successfully")
